<?php
/**
 * Aster Portfolio functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package aster_portfolio
 */

if ( ! defined( 'ASTER_PORTFOLIO_VERSION' ) ) {
	define( 'ASTER_PORTFOLIO_VERSION', '1.0.0' );
}

$aster_portfolio_theme_data = wp_get_theme();
if( ! defined( 'ASTER_PORTFOLIO_THEME_VERSION' ) ) define ( 'ASTER_PORTFOLIO_THEME_VERSION', $aster_portfolio_theme_data->get( 'Version' ) );
if( ! defined( 'ASTER_PORTFOLIO_THEME_NAME' ) ) define( 'ASTER_PORTFOLIO_THEME_NAME', $aster_portfolio_theme_data->get( 'Name' ) );

if ( ! function_exists( 'aster_portfolio_setup' ) ) :
	
	function aster_portfolio_setup() {
		
		load_theme_textdomain( 'aster-portfolio', get_template_directory() . '/languages' );

		add_theme_support( 'woocommerce' );

		add_theme_support( 'automatic-feed-links' );
		
		add_theme_support( 'title-tag' );

		add_theme_support( 'post-thumbnails' );

		register_nav_menus(
			array(
				'primary' => esc_html__( 'Primary', 'aster-portfolio' ),
			)
		);

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
				'woocommerce',
			)
		);

		add_theme_support( 'post-formats', array(
			'image',
			'video',
			'gallery',
			'audio', 
		) );

		add_theme_support(
			'custom-background',
			apply_filters(
				'aster_portfolio_custom_background_args',
				array(
					'default-color' => 'ffffff',
					'default-image' => '',
				)
			)
		);

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 250,
				'width'       => 250,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		add_theme_support( 'align-wide' );

		add_theme_support( 'responsive-embeds' );

		/*  Demo Import */
		require get_parent_theme_file_path( '/theme-wizard/config.php' );

		/*
		* This theme styles the visual editor to resemble the theme style,
		* specifically font, colors, icons, and column width.
		*/
		add_editor_style( '/resource/css/editor-style.css' );

	}
endif;
add_action( 'after_setup_theme', 'aster_portfolio_setup' );

function aster_portfolio_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'aster_portfolio_content_width', 640 );
}
add_action( 'after_setup_theme', 'aster_portfolio_content_width', 0 );

function aster_portfolio_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'aster-portfolio' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'aster-portfolio' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title"><span>',
			'after_title'   => '</span></h2>',
		)
	);

	// Regsiter 4 footer widgets.
	$aster_portfolio_footer_widget_column = get_theme_mod('aster_portfolio_footer_widget_column','4');
	for ($aster_portfolio_i=1; $aster_portfolio_i<=$aster_portfolio_footer_widget_column; $aster_portfolio_i++) {
		register_sidebar( array(
			'name' => __( 'Footer  ', 'aster-portfolio' )  . $aster_portfolio_i,
			'id' => 'footer-widget-' . $aster_portfolio_i,
			'description' => __( 'The Footer Widget Area', 'aster-portfolio' )  . $aster_portfolio_i,
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget' => '</aside>',
			'before_title' => '<div class="widget-header"><h4 class="widget-title">',
			'after_title' => '</h4></div>',
		) );
	}
}
add_action( 'widgets_init', 'aster_portfolio_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function aster_portfolio_scripts() {
	// Append .min if SCRIPT_DEBUG is false.
	$min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';

	// Fontawesome style.
	wp_enqueue_style( 'font-awesome-css', esc_url(get_template_directory_uri())."/resource/css/fontawesome-all.css" );

	// Main style.
	wp_enqueue_style( 'aster-portfolio-style', get_template_directory_uri() . '/style.css', array(), ASTER_PORTFOLIO_VERSION );

	// RTL style.
	wp_style_add_data('aster-portfolio-style', 'rtl', 'replace');

	if (get_theme_mod('aster_portfolio_enable_animation', true) == true){
		// Animate CSS
		wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/resource/css/animate.css' );
		// Wow script.
		wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/resource/js/wow.js', array('jquery'),'' ,true );
	}

	wp_enqueue_style( 'owl.carousel-css', esc_url(get_template_directory_uri())."/resource/css/owl.carousel.css" );

	// Navigation script.
	wp_enqueue_script( 'aster-portfolio-navigation-script', get_template_directory_uri() . '/resource/js/navigation.js', array(), ASTER_PORTFOLIO_VERSION, true );

	// Custom script.
	wp_enqueue_script( 'aster-portfolio-custom-script', get_template_directory_uri() . '/resource/js/custom.js', array( 'jquery' ), ASTER_PORTFOLIO_VERSION, true );


	wp_enqueue_script( 'owl.carousel-js', esc_url(get_template_directory_uri()). '/resource/js/owl.carousel.js', array('jquery') );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	// Include the file.
	require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

	// Load the webfont.
	wp_enqueue_style(
		'DM Sans',
		Aster_Portfolio_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=DM+Sans:ital,opsz,wght@0,9..40,100..1000;1,9..40,100..1000&display=swap' ),
		array(),
		'1.0'
	);

	// Load the webfont.
	wp_enqueue_style(
		'Sora',
		Aster_Portfolio_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Sora:wght@100..800&display=swap' ),
		array(),
		'1.0'
	);

	// Load the webfont.
	wp_enqueue_style(
		'Oxanium',
		Aster_Portfolio_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Oxanium:wght@200..800&display=swap' ),
		array(),
		'1.0'
	);

	// Load the webfont.
	wp_enqueue_style(
		'Eater',
		Aster_Portfolio_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Eater&display=swap' ),
		array(),
		'1.0'
	);

}
add_action( 'wp_enqueue_scripts', 'aster_portfolio_scripts' );

//Change number of products per page 
add_filter( 'loop_shop_per_page', 'aster_portfolio_products_per_page' );
function aster_portfolio_products_per_page( $cols ) {
  	return  get_theme_mod( 'aster_portfolio_products_per_page',9);
}

// Change number or products per row 
add_filter('loop_shop_columns', 'aster_portfolio_loop_columns');
	if (!function_exists('aster_portfolio_loop_columns')) {
	function aster_portfolio_loop_columns() {
		return get_theme_mod( 'aster_portfolio_products_per_row', 3 );
	}
}

/**
 * Include wptt webfont loader.
 */
require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/theme-library/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/theme-library/function-files/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/theme-library/function-files/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/theme-library/customizer.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/theme-library/function-files/google-fonts.php';

/**
 * Dynamic CSS
 */
require get_template_directory() . '/theme-library/dynamic-css.php';

/**
 * Breadcrumb
 */
require get_template_directory() . '/theme-library/function-files/class-breadcrumb-trail.php';

/**
 * Customizer Settings Functions
*/
require get_template_directory() . '/theme-library/function-files/customizer-settings-functions.php';

/**
 * Getting Started
*/
require get_template_directory() . '/theme-library/getting-started/getting-started.php';

function aster_portfolio_links_setup() {
	if ( ! defined( 'ASTER_PORTFOLIO_PREMIUM_PAGE' ) ) {
	define('ASTER_PORTFOLIO_PREMIUM_PAGE',__('https://asterthemes.com/products/creative-portfolio-wordpress-theme','aster-portfolio'));
	}
	if ( ! defined( 'ASTER_PORTFOLIO_THEME_PAGE' ) ) {
		define('ASTER_PORTFOLIO_THEME_PAGE',__('https://asterthemes.com/products/aster-portfolio','aster-portfolio'));
	}
	if ( ! defined( 'ASTER_PORTFOLIO_SUPPORT' ) ) {
	define('ASTER_PORTFOLIO_SUPPORT',__('https://wordpress.org/support/theme/aster-portfolio/','aster-portfolio'));
	}
	if ( ! defined( 'ASTER_PORTFOLIO_REVIEW' ) ) {
	define('ASTER_PORTFOLIO_REVIEW',__('https://wordpress.org/support/theme/aster-portfolio/reviews/','aster-portfolio'));
	}
	if ( ! defined( 'ASTER_PORTFOLIO_PRO_DEMO' ) ) {
	define('ASTER_PORTFOLIO_PRO_DEMO',__('https://demo.asterthemes.com/aster-portfolio/','aster-portfolio'));
	}
	if ( ! defined( 'ASTER_PORTFOLIO_THEME_DOCUMENTATION' ) ) {
	define('ASTER_PORTFOLIO_THEME_DOCUMENTATION',__('https://demo.asterthemes.com/docs/aster-portfolio-free/','aster-portfolio'));
	}
	if ( ! defined( 'ASTER_PORTFOLIO_PREMIUM_DOCUMENTATION' ) ) {
	define('ASTER_PORTFOLIO_PREMIUM_DOCUMENTATION',__('https://demo.asterthemes.com/docs/aster-portfolio-pro/','aster-portfolio'));
	}
	if ( ! defined( 'ASTER_PORTFOLIO_BUNDLE_PAGE' ) ) {
		define('ASTER_PORTFOLIO_BUNDLE_PAGE',__('https://asterthemes.com/products/wp-theme-bundle','aster-portfolio'));
	}
}
add_action('after_setup_theme', 'aster_portfolio_links_setup');

// Enqueue Customizer live preview script
function aster_portfolio_customizer_live_preview() {
    wp_enqueue_script(
        'aster-portfolio-customizer',
        get_template_directory_uri() . '/resource/js/customizer.js',
        array('jquery', 'customize-preview'),
        '',
        true
    );
}
add_action('customize_preview_init', 'aster_portfolio_customizer_live_preview');

// Featured Image Dimension
function aster_portfolio_blog_post_featured_image_dimension(){
	if(get_theme_mod('aster_portfolio_blog_post_featured_image_dimension') == 'custom' ) {
		return true;
	}
	return false;
}

// Add animation class
if ( class_exists( 'WooCommerce' ) ) { 
	add_filter('post_class', function($aster_portfolio_classes, $class, $product_id) {

	    if( is_shop() || is_product_category() || is_product() ){
	        
	        $aster_portfolio_classes = array_merge(['wow','zoomIn'], $aster_portfolio_classes);
	    }

	    return $aster_portfolio_classes;

	}, 10, 3);
}
//woocommerce-end//

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );